Signal Inserter

Using the Signal Inserter Tool

Use the Agilent Signal Inserter tool to translate IQ data from other tools into a CSV format which can be used by the pattern generator to control the Agilent N4860A or N4861A digital stimulus probe.

  • Starting the Signal Inserter
    • Command Line Options
  • Generate DigRF Tab
  • Translate DigRF Tab
  • Insert DigRF Tab
  • Generate CSI-2/DSI Tab
  • Translate CSI-2/DSI Tab
  • Generate IQ Tab

See Also

  • N4850/60A DigRFv3 Acquisition/Stimulus Probes
  • N4851/61A MIPI Acquisition/Stimulus Probes
  • Pattern Generator

  • Agilent N4860A Digital Stimulus Probe User's Guide or Agilent N4861A MIPI D-PHY Stimulus Probe User's Guide discusses the use of this tool in more detail, and provides examples of the input and output file formats. This document is provided with the stimulus probe, and is available from www.agilent.com or ftp://ftp.cos.agilent.com/outbound/N4850A_N4860A/.

© Agilent Technologies, Inc. 2001-2009


Starting the Signal Inserter

To start the signal inserter tool, select Start>Agilent Logic Analyzer>Utilities>Signal Inserter.

You can also run the signal inserter tool from the command line.


Command Line

To run the signal inserter from the command line

The signal inserter utility can also be executed as a command line utility. The default install location of the executable is:

C:\Program Files\Agilent Technologies\Logic Analyzer\agDigRfTranslator.exe

Protocol options

/digrf  (DigRF v3)
/csi-2  (MIPI Camera Serial Interface 2)
/dsi    (MIPI Display Serial Interface V1.0)
/dsi_01 (MIPI Display Serial Interface V1.01.00)
/iq     (Raw IQ data, no protocol, no framing)

The default protocol is DigRF v3, omitting the protocol option is equivalent to specifying option /digrf. If there is more than one protocol on the command line, an error message is output and there is no action taken.

Action options

/generate
/translate
/insert

These correspond to the “Generate the Output CSV file” on each tab of the dialog. If there is more than one action, an error message is output and there is no action taken.

File name options

/input filename
/output filename
/replace filename

All actions require an input file and an output file, except Generate DigRF where the input file is optional. For the /insert action, a /replace file is required. The /replace file option is not allowed for the other actions.

Additional options for /generate

/type signal_file_type

The signal_file_type is the file name, without extension, of the .XML file that describes the signal file. The defined files are:

File Name              Title (appears in user interface)
Binary_16-bit_IQ_lsb   Binary 16-bit, I-lsb, I-msb, Q-lsb, Q-msb
Binary_16-bit_IQ_msb   Binary 16-bit, I-msb, I-lsb, Q-msb, Q-lsb
Binary_16-bit_QI_lsb   Binary 16-bit, Q-lsb, Q-msb, I-lsb, I-msb
Binary_16-bit_QI_msb   Binary 16-bit, Q-msb, Q-lsb, I-msb, I-lsb
ESG_Arb_Format         ESG Arb Format
N5110A_Format          N5110A Format
TwoColumnAsciiDecimal  Two Column Ascii Decimal
/payload size_in_bits
  32, 64, 96, 128, 256, 512

/channel data_channel_letter
A, B, C, D, E, F, G or H

/size IQ_size
8, 12 or 16

/wait time_string
wait time in engineering time format, i.e. 2.083333us

/ticks integer
wait time as a decimal number of 78 MHz clock ticks

/control[1-4]
generate the control frame using the corresponding [1-4] options

/width[1-4] size_in_bits
  8, 32

/channel[1-4] channel_number
  0 (Interface Control)
  1 (Time Accurate Strobe)
  2 (RFIC Control; RFIC Read)
  3 (CTS Transfer)

/cts cts_bit
  0, 1

/wait[1-4] time_string
  wait time in engineering time format, i.e. 2.083333us

/data[1-4] hex_string

/initframes filename
  path name of the Init Frames Module CSV file

/mainframes filename
  path name of the Main Frames Module CSV file

/linestart
  generate Line Start/End packets (MIPI image file only)

/ecc
  generate ECC in MIPI packet headers (MIPI image file only) .  If this option is not specified then zero is generated for all ECC.

/crc
  generate CRC in MIPI packet footers (MIPI image file only) .  If this option is not specified then zero is generated for all CRC.

/imagetype        CSI:              DSI:
              0 = RGB444            RGB565
              1 = RGB555            RGB666
              2 = RGB565            RGB666 Loosely Packed
              3 = RGB666            RGB888
              4 = RGB888            na
              5 = YUV420 8          na
              6 = YUV420 10         na
              7 = YUV420 8 Legacy   na
              8 = YUV420 8 Shifted  na
              9 = YUV420 10 Shifted na
              10 = YUV422 8         na
              11 = YUV422 10        na

  The imagetype option indicates how to format image data in MIPI pixel packets.

Additional options for /insert

/type signal_file_type  (same values as above)
/algorithm replacement_algorithm

The replacement_algorithm is the file name, without extension, of the .XML file that describes the algorithm. The defined files are:

File Name                           Title (appears in user interface)
Channel_A_128-bit_payload_8-bit_IQ  Insert to Channel A, 128-bit payload, 8-bit I and Q
etc.

Both of these options (/type and /algorithm) are required for the /insert action.

Other Options

/nomessage

Do not output any messages. Messages require a response (Press enter to continue…). When using this command line in scripting languages that could cause an unwanted pause. Scripting language users may prefer to rely on the exit status, 0 for success, and 1 for failure.

/?

Print a command line summary

Example command lines

To generate a Pattern Generator CSV file from an IQ data file:

agDigRfTranslator /generate /input "C:\Documents and Settings\user\
  My Documents\Agilent Technologies\Logic Analyzer\DigRf Files\bs_tx.dat"
  /output "C:\Documents and Settings\user\My Documents\Agilent
  Technologies\Logic Analyzer\DigRf Files\TestMode1_Rx_Mod_out.csv"
  /type TwoColumnAsciiDecimal /payload 256 /channel C
  /size 8 /wait 2.08333333us /control1 /width1 32 /channel1 0
  /wait1 23us /data1 12345678

To translate a Module CSV file of a N4850A trace to Pattern Generator CSV suitable for the N4860A:

agDigRfTranslator /translate /input "C:\Documents and Settings\user\
  My Documents\Agilent Technologies\Logic Analyzer\DigRf Files\
  TestMode1_Rx_Mod.csv" /output "C:\Documents and Settings\user\My
  Documents\Agilent Technologies\Logic Analyzer\DigRf Files\
  TestMode1_Rx_Mod_out.csv"

To Insert (replace) IQ data in a Pattern Generator CSV file with data from a binary IQ file:

agDigRfTranslator /replace /input "C:\Documents and Settings\user\My
  Documents\Agilent Technologies\Logic Analyzer\DigRf
  Files\TestMode1_Rx_Mod.csv" /output "C:\Documents and Settings\user\My
  Documents\Agilent Technologies\Logic Analyzer\DigRf
  Files\TestMode1_Rx_Mod_out2.csv" /replace "C:\Documents and Settings\
  user\My Documents\Agilent Technologies\Logic Analyzer\DigRf Files\bs_tx.dat"
  /type TwoColumnAsciiDecimal /algorithm Channel_A_128-bit_payload_8-bit_IQ


Generate DigRF Tab

The Generate DigRF tab is used to generate a Pattern Generator CSV file from an IQ data file.

  1. Select the file type.
  2. Select the name of the input file.
  3. Set the options.
  4. (Optional) Specify up to four control frames to be inserted into the data at regular intervals.
  5. Click Generate the Output CSV file.

Signal File Type

The file types are explained in detail in the Agilent N4860A DigRF v3 Digital Stimulus Probe User's Guide. The File Type check box is used to enable input of a signal file and generation of data frames. The check is selected by default. If it is de-selected, all controls related to Signal Frames in Main are disabled and only Control Frames will be output.

Options for Insert Signal Frames in Main

Several controls allow you to specify how to packetize the IQ data.

Payload Size, Logical Channel: The Payload Size, Logical Channel, and CTS selections are used to encode the DigRF v3 Frame Header Byte.

IQ Data Size: The IQ Data Size is used to specify the size of the individual I and Q values that are written in the payload. If you choose 8-bit or 12-bit, then the 16-bit values read from the data file are right-shifted to the appropriate size. The box beside the IQ Data Size tells you how many IQ pairs will fit in the chosen Payload Size.

Wait Time: The Wait Time is the length of time to wait between transmitting frames. This time is encoded as a time command in the Pattern Generator sequence.

The Wait Time can be input as Engineering Time (time in units of s, ms, us, ns, or ps) in the left box or as the number of 78 MHz Clock Ticks in the right box. These displays are kept in sync by the software. When you change the value in one box, the value automatically changes in the other box. Since a 78 MHz Clock Tick represents about 12.821ns, the clock ticks do not represent time as precisely as Engineering Time.

Options for Insert Control Frames in Main

Control Frames can be inserted between Data Frames at selected intervals. Up to four different types of control frames can be selected.

Selecting the check box on the left of each row of controls indicates a control frame that is to be inserted.

Width, Channel: Control Frames can be either 8 bits or 32 bits and can be transmitted on channels 0..3. These two values and CTS are used to encode the header byte for the frame.

Wait Time: The Wait Time indicates the amount of time between each of these Control Frames.

Data: The Data field is the contents of the Control Frame payload. Placing the same data in every instance of a control frame is an obvious weakness of this interface. We will likely need to enhance this feature, but it's a start.

Options for Insert Control Frames from Module CSV

The second method for inserting control frames reads control frames from a Module CSV file and inserts them in the sequence. The check box on each row enables the option. You can specify a file to insert in the INIT part of the sequence and/or a file for the Main part of the sequence.


Translate DigRF Tab

The Translate DigRF tab is used to translate between pattern generator file formats.

The operation is chosen based upon the input file type. So in each case, the procedure is:

  1. Select an input file.
  2. Enter a name for the output CSV file.
  3. Click Generate the Output CSV file.

Translating to Pattern Generator CSV

If the input file is a Module CSV file or an XML description file, it will be translated to a Pattern Generator CSV file.

You can create a Module CSV file yourself. You can also capture a signal using the N4850A acquisition probe, save it as a CSV file, then translate it to Pattern Generator CSV for use as stimulus.

For more information on Module CSV and XML files, see the N4860A User's Guide.

Translating to Module CSV

If the input is a Pattern Generator CSV file, it will be translated to a Module CSV file. The Module CSV is the same format as the output of the N4850A acquisition probe. You can load the Module CSV file into the logic analysis system, and use all the analysis tools available there (such as the Packet Decoder tool, the Packet Viewer display, and the Signal Extractor). This is useful for verifying that you have created the series of DigRF packets correctly.

Licensed Pattern Generator format

If the input file is Licensed Pattern Generator format, you will get an error message. Translating Licensed Pattern Generator format to Module CSV is not supported.


Insert DigRF Tab

  1. Select an input file.
  2. Enter a name for the output CSV file.
  3. Select the signal to insert.
  4. Click Generate the Output CSV file.

The Insert DigRF tab is used when inserting new IQ data into DigRF frames in a Pattern Generator CSV file.

Signal File Type: select the type of input file that contains the new replacement data.

Insert Algorithm: select the algorithm to be used for replacing data currently in the Pattern Generator CSV file with data from the IQ data file.

Details of the various data files and algorithms are documented in the N4860A User's Guide.

Output Format

The Output Pattern Generator CSV lets you specify the file output by the translation. If the Input File is Licensed Pattern Generator format or if the Signal File Type is Signal Studio, the output will be Licensed Pattern Generator. All other translations result in the same format of CSV output.

Insert Algorithms

Insert Algorithms are described by XML files. The standard algorithms shipped by Agilent are installed at:

C:\Program Files\Agilent Technologies\Logic Analyzer\Translators\DigRf

You can also create your own algorithm files. It may be easiest to do this by copying a standard algorithm file and modifying it. If you don’t have permission to write in the C:\Program Files directory, you can copy the file to:

C:\Documents and Settings\All Users\Shared Documents\Agilent Technologies\Logic Analyzer\Translators\DigRf

Both of these directories are searched for XML files when the signal inserter starts. If you add a new .XML file, exit from signal inserter and restart it to read the new .XML files.


Generate CSI-2/DSI Tab

The Generate CSI-2/DSI tab is used to generate a Pattern Generator CSV file from a data file. The Signal File Type field is used to specify the format of the data in a binary or ASCII file.

  1. Select the protocol.
  2. Select the file type.
  3. Select the name of the input file.
  4. Set the options.
  5. Click Generate the Output CSV file.

Signal File Type

The file types are explained in detail in the Agilent N4861A Stimulus Probe User's Guide and summarized below:

CSI-2/DSI ASCII Frame Format

ASCII Frame Format contains a one-line header and comma-separated ASCII hex values.

Comments are allowed, delimited by either ‘/’ or “#’.

The data lines each comprise the contents of one packet. The header line must contain these labels:

Ticks - number of 5 ns ticks to wait (from the beginning of the file) before outputting this line.

nsTime - time in ns to wait (from the beginning of the file) before outputting this line.

LPS - when 1, output this line in lower power state.

Escape - when 1, enter escape mode.

ULPC - when 1, enter ultra low power mode.

Data - bytes of data for the packet.

The header line must contain either Ticks or nsTime.

Examples

// Example Init Packets in a CSI-2/DSI ASCII Format File
Ticks, LPS, Escape, ULPC, Data
0200, 1, 0, 0, 02, 00, 00, 00
0300, 0, 0, 0, 21, 00, 00, 00

// Example Main Packets in a CSI-2/DSI ASCII Format File
nsTime, LPS, Escape, ULPC, Data
// Start Image Frame 1
02000, 1, 0, 0, 01, 00, 00, 00
03000, 0, 0, 0, 21, 00, 00, 00
04000, 0, 0, 0, 0e, 09, 00, 00, ff, 00, 00, 00, ff, 00, 00, 00, ff, 00, 00

The combo box item text for these option is: CSI-2/DSI Ascii Frame Format

Image File

An Image File can be one of several image formats supported by Windows. Selecting the Image File format enables Image related controls that allow you to specify the manner in which the pixels in the image file will be packetized.

If the Generate Line Start/End Packets box is checked, then there will be a Start Line packet before every line of pixels followed by an End Line packet.

If the Generate ECC box is checked then ECC will be generated in Packet Headers. If it is not checked all ECC will be set to zero.

If the Generate CRC box is checked then CRC will be generated in Packet Footers. If it is not checked all CRC will be set to zero.

After all the options are set up, select the Generate the Output CSV file button to generate the file.


Translate CSI-2/DSI Tab

The Translate CSI-2/DSI tab is used to translate between pattern generator file formats.

The operation is chosen based upon the input file type. So in each case, the procedure is:

  1. Select the protocol.
  2. Select an input file.
  3. Enter a name for the output CSV file.
  4. Click Generate the Output CSV file.

Translating to Pattern Generator CSV

If the input file is a Module CSV file or an XML description file, it will be translated to a Pattern Generator CSV file.

You can create a Module CSV file yourself. You can also capture a signal using the N4851A acquisition probe, save it as a CSV file, then translate it to Pattern Generator CSV for use as stimulus.

For more information on Module CSV and XML files, see the N4861A User's Guide.

Translating to Module CSV

If the input is a Pattern Generator CSV file, it will be translated to a Module CSV file. The Module CSV is the same format as the output of the N4851A acquisition probe. You can load the Module CSV file into the logic analysis system, and use all the analysis tools available there (such as the Packet Decoder tool, the Packet Viewer display, and the Signal Extractor). This is useful for verifying that you have created the stimulus vectors correctly.

Licensed Pattern Generator format

If the input file is Licensed Pattern Generator format, you will get an error message. Translating Licensed Pattern Generator format to Module CSV is not supported.


Generate IQ Tab

The Generate IQ tab is used to generate a Pattern Generator CSV file from an IQ data file.

  1. Select the file type.
  2. Select the name of the input file.
  3. Set the width.
  4. Select a name for the output file.
  5. Click Generate the Output CSV file.

This tab is used to generate a Pattern Generator CSV file that contains only IQ data from the input file. There is no protocol or framing. Width is used to select both the size of the IQ values in the input file and the size of the I and Q labels in the CSV file that is created.

The File Type and File Name fields and theGenerate the Output CSV file button are the same as the Generate DigRF Tab.